#pragma once

#include "Vector.h"
#include "Memory.h"
#include "String.h"

#include "MidiElements.h"

class MidiTrack;
using MidiTrackPtr = Ptr<MidiTrack>;

class MidiDocument
{
public:
    MidiDocument();

    static Ptr<MidiDocument> Create();

    void AddTrack(MidiTrackPtr track);

    void SetFormatType(int format);
    void SetExpectedTracks(int expected);
    void SetTimeDivision(const MidiTimeDivision& timeDivision);

    String Serialize() const;

private:
    int mFormatType = 0;
    int mExpectedTracks = 0;
    MidiTimeDivision mTimeDivision;
    Vector<MidiTrackPtr> mTracks;
};

using MidiDocumentPtr = Ptr<MidiDocument>;
