#pragma once

#include "Vector.h"
#include "Memory.h"
#include "String.h"
#include "MidiEvent.h"

class MidiEvent;
using MidiEventPtr = Ptr<MidiEvent>;

class MidiTrack
{
public:

    MidiTrack();

    ~MidiTrack();

    void AddEvent(MidiEventPtr event);

    MidiEvent* GetEvent(std::size_t idx) const;

    std::size_t GetNumEvents();

    String Serialize() const;

private:

    Vector<MidiEventPtr> mEvents;
};
