#pragma once

#include "BuildLibrary.h"
#include "Error.h"

class BuildSession
{
public:
    BuildSession(const String& source_dir, 
        const String& build_dir = {});

    Status scan();

    Status build();

    Status add_library(const FileSystemPath& config_path);

private:
    String m_compiler_command{"/usr/bin/g++"};
    Vector<String> m_compiler_flags;
    FileSystemPath m_source_dir;
    FileSystemPath m_build_dir;
    Vector<BuildLibrary> m_libraries;
};