#pragma once

#include "String.h"
#include <unordered_map>

class TemplateSubstitutionContext
{
public:

    void addSubstitution(const String& key, const String& value)
    {
        mSubstitutions[key] = value;
    }

    bool hasSubstitution(const String& key) const
    {
        return mSubstitutions.find(key) != mSubstitutions.end();
    }

    String getSubstitution(const String& key) const
    {
        auto iter = mSubstitutions.find(key);
        if(iter != mSubstitutions.end())
        {
            return iter->second;
        }
        else
        {
            return {};
        }
    }

private:
    std::unordered_map<String, String> mSubstitutions;
};
