#include "Dictionary.h"

bool Dictionary::hasKey(const String& key) const
{
    return hasStringKey(key) || hasDictKey(key);
}

bool Dictionary::hasStringKey(const String& key) const
{
    return mStringData.count(key) > 0;
}

bool Dictionary::hasDictKey(const String& key) const
{
    return mDictData.count(key) > 0;
}

Vector<String> Dictionary::getStringKeys() const
{
    Vector<String> keys;
    for (const auto& item : mStringData)
    {
        keys.push_back(item.first);
    }
    return keys;
}

Vector<String> Dictionary::getDictKeys() const
{
    Vector<String> keys;
    for (const auto& item : mDictData)
    {
        keys.push_back(item.first);
    }
    return keys;
}

Dictionary* Dictionary::getDict(const String& key) const
{
    return mDictData.at(key).get();
}

String Dictionary::getItem(const String& key) const
{
    return mStringData.at(key);
}

void Dictionary::addStringItem(const String& key, const String& item)
{
    mStringData[key] = item;
}

void Dictionary::addDictItem(const String& key, Ptr<Dictionary> dict)
{
    mDictData[key] = std::move(dict);
}
