#pragma once

#include "String.h"
#include "Result.h"

class FileSystemPath
{
public:
    FileSystemPath();

    FileSystemPath(const String& path);

    const String& str() const;

    static Result<FileSystemPath> current_dir();

    String extension() const;

    String file_name() const;

    bool exists() const;

    Result<bool> is_empty() const;

    Result<size_t> get_size() const;

    FileSystemPath join(const String& entry) const;

    Result<bool> is_regular_file() const;

    Result<bool> is_directory() const;

    Result<bool> is_regular_file_or_directory() const;

    bool is_absolute() const;

    FileSystemPath parent_path() const;

private:
    String m_delimiter{"/"};
    String m_path;
};