#pragma once

#include "String.h"
#include "Pointer.h"

#define LOG_ALL(msg, level) {String mt_logstream;\
    mt_logstream << msg; \
    Logger::get_instance()->log_line(level, mt_logstream, __FILE__, __FUNCTION__, __LINE__);};
#define LOG_INFO(msg) LOG_ALL(msg, Logger::Level::INFO);
#define LOG_ERROR(msg) LOG_ALL(msg, Logger::Level::ERROR);

class Logger
{
public:
    enum class Level 
    {
        INFO,
        ERROR
    };

    virtual ~Logger() = default;
    virtual void log_line(Level level, 
        const String& line, 
        const String& fileName, 
        const String& functionName, 
        int lineNumber){};

    static Logger* get_instance();

protected:
    static String build_log_message(Level level, 
        const String& line, 
        const String& fileName, 
        const String& functionName, 
        int lineNumber);
};