#pragma once

#include "BitStream.h"

#include <ostream>

class OutputBitStream : public BitStream
{
public:
    OutputBitStream(std::basic_ostream<char>* stream);

    bool isFinished() const override;

    void peekNextNBytes(std::size_t n, VecBytes& bytes) const override;

    std::optional<Byte> readNextByte() override;

    void writeByte(Byte data, bool checkOverflow = true) override;

    void writeBytes(const VecBytes& data) override;

private:
    std::basic_ostream<char>* mStream{nullptr};
};
