#pragma once

#include "Pointer.h"
#include "Vector.h"
#include "String.h"
#include "FileSystemPath.h"

class CommandLineArgs
{
public:
    CommandLineArgs();

    static Ptr<CommandLineArgs> Create();

    FileSystemPath getLaunchPath();

    const Vector<String> getArgs() const;

    Vector<String> getUserArgs() const;

    static void initialize(CommandLineArgs* args);

    void process(int argc, char *argv[]);

    void process(const Vector<String>& args);

    void recordLaunchPath();
private:
    Vector<String> mArugments;
    FileSystemPath mLaunchPath;
};