#pragma once

#include <unordered_map>
#include "Memory.h"
#include <thread>
#include <mutex>
#include <atomic>
#include "Vector.h"

class ThreadCollection
{
public:
	bool add(Ptr<std::thread> thread);

	void joinAndClearAll();

	void markForRemoval(std::thread::thread::id inputId);

	void removeMarked();

	std::size_t size() const;

private:
	void _remove(std::thread::thread::id inputId);

	mutable std::mutex mMutex;
	std::atomic<bool> mAccepting{ true };

	Vector<std::thread::thread::id> mMarkedForRemoval;
	std::unordered_map<std::thread::thread::id, Ptr<std::thread> > mThreads;
};