#include "PointParser.h"

#include <sstream>

String PointParser::toString(const Point2& p, const String& delimiter, std::size_t precision)
{
    return toString(p.getX(), p.getY(), delimiter, precision);
}

String PointParser::toString(const Vector2& v, const String& delimiter, std::size_t precision)
{
    return toString(v.getEntry(0), v.getEntry(1), delimiter, precision);
}

String PointParser::toString(double x, double y, const String& delimiter, std::size_t precision)
{
    if (precision == 0)
    {
        return std::to_string(x) + delimiter + std::to_string(y);
    }
    else
    {
        Stringstream sstr;
        sstr.precision(precision);
        sstr << x << delimiter << y;
        return sstr.str();
    }
}

String PointParser::toString(double x, std::size_t precision)
{
    if (precision == 0)
    {
        return std::to_string(x);
    }
    else
    {
        Stringstream sstr;
        sstr.precision(precision);
        sstr << x;
        return sstr.str();
    }
}

