#pragma once

#include "PlatformSocketServer.h"

#include "Memory.h"

class AbstractWebApp;
class Socket;

class HttpServer
{
public:
	struct Address
	{
		String mPrefix;
		String mHost;
		unsigned int mPort{ 8000 };
	};

	HttpServer();
	~HttpServer();

	void run(AbstractWebApp* webApp, Address mListenAddress);

private:
	void onConnection(Socket* socket);

	void onFailure(const String& reason);

	AbstractWebApp* mWebApp{ nullptr };
	Ptr<PlatformSocketServer> mSocketServer;
};