#pragma once

#include "Socket.h"

#include "String.h"
#include <functional>

class BerkeleySocket : public Socket
{
public:
    BerkeleySocket(const String& address, unsigned port);

    BerkeleySocket(int handle);

    ~BerkeleySocket();

    String recieve() override;

    void respond(const String& message) override;

    String send(const String& message) override;

    using onIncomingConnectionFunc = std::function<void(int)>;
    void doListen(onIncomingConnectionFunc connectionFunc);

private:
    void initialize() override;
    void initializeForBind() override;

    void doConnect() override;

    void doBind() override;

    void onSockerError(const String& message);

    int mHandle{ 0 };
};
