#pragma once

#include "Vector.h"
#include "Memory.h"

class AudioSample
{
public:
    using ChannelData = Vector<short>;

    AudioSample();

    static Ptr<AudioSample> Create();

    ChannelData getChannelData(std::size_t channel) const;
    std::size_t getNumChannels() const;
    unsigned getSampleRate() const;
    unsigned getBitDepth() const;

    void setChannelData(const ChannelData& data, std::size_t channel);

private:
    unsigned mSampleRate { 44100 };
    unsigned mBitDepth{ 16 };
    Vector<ChannelData> mData;
};

using AudioSamplePtr = Ptr<AudioSample>;
