#include "ImageBitStream.h"

#include "Grid.h"
#include "Pixel.h"

ImageBitStream::ImageBitStream(Image* image)
    :   BitStream(),
        mImage(image)
{

}

bool ImageBitStream::isFinished() const
{
    return mByteOffset == static_cast<int>(mImage->getGrid()->getDataSize());
}

Vector<uint8_t> ImageBitStream::peekNextNBytes(std::size_t) const
{
    return {};
}

std::optional<uint8_t> ImageBitStream::readNextByte()
{
    mByteOffset++;
    if (isFinished() )
    {
        return std::nullopt;
    }
    return mImage->getByte(mByteOffset);
}

void ImageBitStream::writeByte(uint8_t, bool )
{
    mByteOffset++;

    if (isFinished() )
    {
        return;
    }
    //mImage->getData()->setDataItem(mByteOffset, data);
}

