#pragma once

#include "Color.h"
#include "Serializeable.h"

class Pixel : public Serializeable
{
public:
    void setColor(const Color& color)
    {
        mColor = color;
    }

    std::size_t getSize() const override
    {
        return mColor.getSize();
    }

    uint8_t getByte(std::size_t index) const override
    {
        return mColor.getByte(index);
    }

private:
    Color mColor;
};