#pragma once

#include "File.h"
#include "Image.h"
#include "PngHeader.h"
#include "ZlibEncoder.h"

#include "String.h"
#include "Memory.h"
#include <filesystem>

class BitStream;
class ZlibEncoder;

using Path = std::filesystem::path;

class PngReader
{
public:
    ~PngReader();
    void setPath(const Path& path);

    Ptr<Image> read();
private:
    bool readChunk();

    bool readHeaderChunk();

    bool readIDATChunk(unsigned length);

    bool checkSignature();

    void decodeData();

    PngHeader mHeader;

    Ptr<Image> mWorkingImage;
    Ptr<File> mFile;
    Path mPath;

    Ptr<ZlibEncoder> mEncoder;
    Ptr<BitStream> mInputStream;
    Ptr<BitStream> mOutputStream;
    bool mProcessingDatablocks{false};
};
