#pragma once

#include <filesystem>
#include "String.h"

using Path = std::filesystem::path;

class FontItem
{
public:
    FontItem(const String& faceName = "Arial", float size = 16);

    const Path& getPath() const;

    const String& getFaceName() const;

    float getSize() const;

    void setPath(const Path& path);

    bool hasPath() const;

    bool operator==(const FontItem& rhs) const
    {
       return (mSize == rhs.mSize)
       && (mFaceName == rhs.mFaceName);
    }

    bool operator!=(const FontItem& rhs) const
    {
      return !operator==(rhs);
    }

private:
    float mSize{24};
    String mFaceName;
    Path mPath;
};
