#pragma once

#include "AbstractPainter.h"

#include <unordered_map>
#include "Memory.h"

class DrawingContext;
class OpenGlMeshPainter;
class OpenGlTextPainter;

class TriMesh;

class OpenGlPainter : public AbstractPainter
{
public:
    OpenGlPainter(DrawingContext* context);
    void paint() override;

private:
    Ptr<OpenGlMeshPainter> mMeshPainter;
    Ptr<OpenGlTextPainter> mTextPainter;
};


