#include "AbstractFace.h"

#include "Edge.h"

AbstractFace::AbstractFace(std::size_t id)
    : mId(id)
{

}

AbstractFace::~AbstractFace()
{

}

void AbstractFace::addVectorAttribute(const String& tag, const Vector<double>& values)
{
    mVectorAttributes[tag] = values;
}

Vector<double> AbstractFace::getVectorAttribute(const String& tag) const
{
    auto iter = mVectorAttributes.find(tag);
    if (iter != mVectorAttributes.end())
    {
        return iter->second;
    }
    return {};
}

void AbstractFace::setIndex(std::size_t idx)
{
    mId = idx;
}
