#pragma once

#include "AbstractMesh.h"

#include "String.h"
#include <unordered_map>

class Edge;
using EdgePtr = Ptr<Edge>;
using VecEdges = Vector<EdgePtr>;

class LineMesh : public AbstractMesh
{
public:
    LineMesh() = default;

    ~LineMesh();

    void populate(VecNodes& nodes, VecEdges& edges);

    Vector<std::size_t> getEdgeNodeIds() const;

    MeshType getType() const override;

    Ptr<AbstractMesh> copy() const override;

private:
    VecEdges mEdges;
};
