#pragma once

#include "GeometryNode.h"

#include "Memory.h"

class PathNode : public GeometryNode
{
public:
    PathNode(const Transform& transform, const String& psPath);
    static Ptr<PathNode> Create(const Transform& transform, const String& psPath);

    GeometryNode::Type getType() override;

    const String& getPathString() const;

    void setPathString(const String& psPath);

private:
    void createOrUpdateGeometry(SceneInfo* sceneInfo) override;

    String mPathString;
};