#pragma once

#include "TextData.h"
#include "SceneInfo.h"
#include "Color.h"
#include "Transform.h"

#include "Vector.h"
#include "Memory.h"

class RootNode;
class AbstractVisualNode;
class SceneItem;

class Scene
{
public:
    Scene();

    ~Scene();

    void addNode(AbstractVisualNode* node);

    const Vector<SceneItem*>& getItems() const;

    const Color& getBackgroundColor() const;

    bool isEmpty() const;

    bool shouldShowMeshOutline() const;

    void setBackgroundColor(const Color&);

    void setShowMeshOutline(bool shouldShow);

    void setFontsManager(FontsManager* fontsManager);

    void setSupportsGeometryPrimitives(bool supports);

    void update();
private:
    void updateNode(AbstractVisualNode* node, const Transform& transform);

    Color mBackGroundColor;
    Ptr<RootNode> mRootNode;
    Vector<SceneItem*> mSceneItems;
    Ptr<SceneInfo> mSceneInfo;
};
