#pragma once

#include "MaterialNode.h"
#include "GeometryNode.h"
#include "SvgDocument.h"

#include "Memory.h"
#include "Vector.h"

class SvgNode : public MaterialNode
{
public:
    SvgNode(const Transform& transform);

    unsigned getContentWidth() const;
    unsigned getContentHeight() const;

    void setContent(Ptr<SvgDocument> doc);

    void update(SceneInfo* sceneInfo);
private:
    void createOrUpdateGeometry(SceneInfo* sceneInfo);

    void onCircle(XmlElement* element, Ptr<GeometryNode>& node);
    void onPath(XmlElement* element, Ptr<GeometryNode>& node);

    bool mContentDirty{ true };

    unsigned mContentWidth{ 1 };
    unsigned mContentHeight{ 1 };

    Vector<Ptr<GeometryNode> > mGeometryNodes;
    Ptr<SvgDocument> mContent;
};
