#pragma once

#include "Widget.h"

#include "String.h"

class TextNode;

class TextBox : public Widget
{
public:
    TextBox();

    static Ptr<TextBox> Create();

    void setContent(const String& text);

    String getContent() const;

    void appendContent(const String& text);

    //void onPaintEvent(const PaintEvent* event) override;

    bool onMyKeyboardEvent(const KeyboardEvent* event) override;

private:
    bool isDirty() const override;
    void doPaint(const PaintEvent* event) override;

    void updateLabel(const PaintEvent* event);

    String mContent;
    Ptr<TextNode> mTextNode;
    bool mContentDirty{true};
};

using TextBoxUPtr = Ptr<TextBox>;
