#pragma once

#include "AbstractUiInterface.h"

#include "Memory.h"

class DesktopManager;

class UiInterfaceFactory
{
public:
    enum class Backend
    {
        UNSET,
        X11_RASTER,
        X11,
        WAYLAND_RASTER,
        WAYLAND
    };

    static Ptr<AbstractUIInterface> create(DesktopManager* desktopManager, Backend backend = Backend::UNSET);
};
